 processor 6502
 include "vcs.h"
 include "macro.h"
 include "2600basic.h"
 include "2600basic_variable_redefs.h"
 ifconst bankswitch
  if bankswitch == 8
     ORG $1000
     RORG $D000
  endif
  if bankswitch == 16
     ORG $1000
     RORG $9000
  endif
  if bankswitch == 32
     ORG $1000
     RORG $1000
  endif
 else
   ORG $F000
 endif
; This is a 2-line kernel!
kernel
 lda bally
 sta stack2
 lda #1
 sta VDELBL
 sta VDELP0
 ldx missile1height
 inx
 sta WSYNC
 inx
 stx stack1
 ldx #0
 lda #4
 stx GRP0
 stx GRP1
 stx PF1
 stx PF2
 stx CXCLR
 sta temp4 ; pointer to PF gfx

 lda player0y ;store these so they can be retrieved later
 sta temp2
 lda player1y
 sta temp3

 lda missile0y
 sta temp5
 lda missile1y
 sta temp6

 lda playfieldpos
 sta temp1

 
 jmp .startkernel

.skipDrawP0
 sleep 2
 lda #0
 jmp .continueP0

.skipDrawP1
 sleep 2
 lda #0
 jmp .continueP1

.kerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

; tya
goback
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
.startkernel
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continueP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16
 rol;2
 rol;2
 sta ENAM0 ;3


 ;missile/ball? 
 lda playfield,x ;4
 sta PF1 ;3
 lda playfield+1,x ;4
 sta PF2 ;3
 lda playfield+3,x ;4
 sta PF1 ; 3 too early?
 lda playfield+2,x;4
 sta PF2 ;3
 
 dec temp1
 beq altkernel
; sleep 3

 lda player1height
 dcp player1y
 bcc .skipDrawP1
 ldy player1y
 lda (player1pointer),y
.continueP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .kerloop

; sleep 2
; dex
; bne .kerloop

; beq endkernel

altkernel

 lda player1height
 dcp player1y
 bcc .skipDrawaltP1
 ldy player1y
 lda (player1pointer),y
.continuealtP1
 sta GRP1

 lda missile1height ;3
 dcp missile1y ;5
 ;c=1 active
; ldy temp4 ;3
; lda #0 ;14
; adc #1 ;16
 sbc stack1
 sta ENAM1 ;3

; sleep 2

 lda #0
 sta PF1
 sta PF2

 ;sleep 3

 ;28 cycles to fix things
 ;minus 11=17

; lax temp4
; clc
 txa
 adc #4
 tax
 cmp #44
 bne skiplastkernelline
 lda #9
 sbc playfieldpos
 sta temp4
 lda.w ballheight
 jmp enterlastkernel
skiplastkernelline

 sta temp4
 lda #8
 sta temp1
 lda ballheight

 jmp goback

 ;align 256

.skipDrawaltP1
 sleep 2
 lda #0
 jmp .continuealtP1

.skipDrawlastP0
 sleep 2
 lda #0
 jmp .continuelastP0

.endkerloop ; enter at cycle 59??
 
 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

enterlastkernel
; tya
 dcp bally
; sleep 4

; sbc stack3
 rol
 rol
 sta ENABL 
 lda player0height ;3
 dcp player0y ;5
 bcc .skipDrawlastP0 ;2
 ldy player0y ;3
 lda (player0pointer),y ;5; player0pointer must be selected carefully by the compiler
			; so it doesn't cross a page boundary!

.continuelastP0
 sta GRP0 ;3
 lda missile0height ;3
 dcp missile0y ;5
; sbc stack1
 ;c=1 active
; ldy temp4 ;3;playfield counter
; lda #0 ;14
; lax temp4
; adc #1 ;16

 dec temp4
 beq endkernel
; sleep 3


 ;missile/ball? 
 ldy playfield,x ;4
 sty PF1 ;3
 ldy playfield+1,x ;4
 sty PF2 ;3
 ldy playfield+3,x ;4
 sty PF1 ; 3 too early?
 ldy playfield+2,x;4
 sty PF2 ;3

 rol;2
 rol;2
 sta ENAM0 ;3
 

 lda player1height
 dcp player1y
 bcc .skipDrawlastP1
 ldy player1y
 lda (player1pointer),y
.continuelastP1
 sta GRP1


 lda missile1height ;3
 dcp missile1y ;5
 sbc stack1
 ;c=1 active
; lax temp4 ;3
; lda #0 ;14
; adc #1 ;16
; rol;2
; rol;2
 sta ENAM1 ;3
 lda ballheight

; sleep 3
; lda ballheight
 jmp .endkerloop


.skipDrawlastP1
 sleep 2
 lda #0
 jmp .continuelastP1


endkernel
 ; 6 digit score routine
 lda #0
 sta PF1
 sta PF2
 
                STA WSYNC ;first one, need one more
;                LDA #0
 sta REFP0
 sta REFP1
                STA GRP0
                STA GRP1
 ;               STA PF1
   ;             STA PF2
 sta HMCLR
 sta ENAM0
 sta ENAM1
 sta ENABL
 sta WSYNC
 sleep 2
                STA GRP0
                STA GRP1 ; seems to be needed because of vdel

                LDY #7
                STY temp1
        LDA #$03
        STA NUSIZ0
        STA NUSIZ1
        STA VDELP0
        STA VDELP1
        LDA #$F0
        STA HMP0
               LDA scorecolor 
                nop
                STA RESP0
                STA RESP1
                STA COLUP0
                STA COLUP1
;               STA HMCLR
                STA WSYNC; second one
                STA HMOVE

loop2
 ldy  temp1        ;+3  63  189
 lda  (scorepointers),y     ;+5  68  204
 sta  GRP0            ;+3  71  213      D1     --      --     --
 sta  WSYNC           ;go
 lda  (scorepointers+$2),y  ;+5   5   15
 sta  GRP1            ;+3   8   24      D1     D1      D2     --
 lda  (scorepointers+$4),y  ;+5  13   39
 sta  GRP0            ;+3  16   48      D3     D1      D2     D2
 lda  (scorepointers+$6),y  ;+5  21   63
 sta  temp4         ;+3  24   72
 lda  (scorepointers+$8),y  ;+5  29   87
 tax                  ;+2  31   93
 lda  (scorepointers+$A),y  ;+5  36  108
 tay                  ;+2  38  114
 lda  temp4         ;+3  41  123              !
 sta  GRP1            ;+3  44  132      D3     D3      D4     D2!
 stx  GRP0            ;+3  47  141      D5     D3!     D4     D4
 sty  GRP1            ;+3  50  150      D5     D5      D6     D4!
 sta  GRP0            ;+3  53  159      D4*    D5!     D6     D6
 dec  temp1        ;+5  58  174                             !
 bpl  loop2           ;+2  60  180
 
                STA WSYNC       ;JUST ADDED
                LDA #0   
               STA GRP0
                STA GRP1
        STA VDELP0
        STA VDELP1;do we need these
        STA NUSIZ0
        STA NUSIZ1

 lda temp2 ;restore variables that were obliterated by kernel
 sta player0y
 lda temp3
 sta player1y
 lda temp5
 sta missile0y
 lda temp6
 sta missile1y
 lda stack2
 sta bally

 ifnconst vblank_time
 lda #43+128
 else
 lda #vblank_time+128
 endif

 sta TIM64T
 LDA #%01000010
 sta WSYNC
 STA VBLANK
 RETURN
start
 sei
 cld
 ldx #0
 txa
clearmem
 inx
 txs
 pha
 bne clearmem
 lda #8
 sta playfieldpos
 ldx #11
initscore
 lda #>scoretable
 sta scorepointers,x 
 dex
 lda #<scoretable
 sta scorepointers,x 
 dex
 bpl initscore
 lda #1
 sta CTRLPF
 ora INTIM
 sta rand

 ifconst multisprite
   jsr multisprite_setup
 endif

 ifnconst bankswitch
   jmp game
 else
   lda #>(game-1)
   pha
   lda #<(game-1)
   pha
   pha
   pha
   ldx #1
   jmp BS_jsr
 endif
; playfield drawing routines
; you get a 32x12 bitmapped display in a single color :)
; 0-31 and 0-11

pfclear ; clears playfield - or fill with pattern
 ldx #47
pfclear_loop
 sta playfield,x
 dex
 bpl pfclear_loop
 RETURN
 
setuppointers
 stx temp2 ; store on.off.flip value
 tax ; put x-value in x 
 lsr
 lsr
 lsr ; divide x pos by 8 
 sta temp1
 tya
 asl
 asl ; multiply y pos by 4
 clc
 adc temp1 ; add them together to get actual memory location offset
 tay ; put the value in y
 lda temp2 ; restore on.off.flip value
 rts

pfread
;x=xvalue, y=yvalue
 jsr setuppointers
 lda setbyte,x
 and playfield,y
 eor setbyte,x
; beq readzero
; lda #1
; readzero
 RETURN

pfpixel
;x=xvalue, y=yvalue, a=0,1,2
 jsr setuppointers

 ifconst bankswitch
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon_r  ; if "on" go to on
 lsr
 bcs pixeloff_r ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
 sta playfield,y
 rts
pixelon_r
 lda playfield,y
 ora setbyte,x
 sta playfield,y
 rts
pixeloff_r
 lda setbyte,x
 eor #$ff
 and playfield,y
 sta playfield,y
 RETURN

 else
 jmp plotpoint
 endif

pfhline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 jmp noinc
keepgoing
 inx
 txa
 and #7
 bne noinc
 iny
noinc
 jsr plotpoint
 cpx temp3
 bmi keepgoing
 RETURN

pfvline
;x=xvalue, y=yvalue, a=0,1,2, temp3=endx
 jsr setuppointers
 sty temp1 ; store memory location offset
 inc temp3 ; increase final x by 1 
 lda temp3
 asl
 asl ; multiply by 4
 sta temp3 ; store it
 ; Thanks to Michael Rideout for fixing a bug in this code
 ; right now, temp1=y=starting memory location, temp3=final
 ; x should equal original x value
keepgoingy
 jsr plotpoint
 iny
 iny
 iny
 iny
 cpy temp3
 bmi keepgoingy
 RETURN

plotpoint
 lda temp2 ; load on.off.flip value (0,1, or 2)
 beq pixelon  ; if "on" go to on
 lsr
 bcs pixeloff ; value is 1 if true
 lda playfield,y ; if here, it's "flip"
 eor setbyte,x
 sta playfield,y
 rts
pixelon
 lda playfield,y
 ora setbyte,x
 sta playfield,y
 rts
pixeloff
 lda setbyte,x
 eor #$ff
 and playfield,y
 sta playfield,y
 rts

setbyte
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
 .byte $80
 .byte $40
 .byte $20
 .byte $10
 .byte $08
 .byte $04
 .byte $02
 .byte $01
 .byte $01
 .byte $02
 .byte $04
 .byte $08
 .byte $10
 .byte $20
 .byte $40
 .byte $80
pfscroll ;(a=0 left, 1 right, 2 up, 4 down, 6=upup, 12=downdown)
 bne notleft
;left
 ldx #48
leftloop
 lda playfield-1,x
 lsr
 rol playfield-2,x
 ror playfield-3,x
 rol playfield-4,x
 ror playfield-1,x
; txa
; sbx #4
 dex
 dex
 dex
 dex
 bne leftloop
 RETURN

notleft
 lsr
 bcc notright
;right

 ldx #48
rightloop
 lda playfield-4,x
 lsr
 rol playfield-3,x
 ror playfield-2,x
 rol playfield-1,x
 ror playfield-4,x
 dex
 dex
 dex
 dex
; sbx #4
 bne rightloop
  RETURN

notright
 lsr
 bcc notup
;up
 lsr
 bcc onedecup
 dec playfieldpos
onedecup
 dec playfieldpos
 beq shiftdown 
 bpl noshiftdown2 
shiftdown
 lda #8
 sta playfieldpos
 lda playfield+3
 sta temp4
 lda playfield+2
 sta temp3
 lda playfield+1
 sta temp2
 lda playfield
 sta temp1
 ldx #0
up2
 lda playfield+4,x
 sta playfield,x
 lda playfield+5,x
 sta playfield+1,x
 lda playfield+6,x
 sta playfield+2,x
 lda playfield+7,x
 sta playfield+3,x

 inx
 inx
 inx
 inx
 cpx #44
 bne up2
 
 lda temp4
 sta playfield+47
 lda temp3
 sta playfield+46
 lda temp2
 sta playfield+45
 lda temp1
 sta playfield+44
noshiftdown2
 RETURN


notup
;down
 lsr
 bcs oneincup
 inc playfieldpos
oneincup
 inc playfieldpos
 lda playfieldpos
 cmp #9
 bcc noshiftdown 
 lda #1
 sta playfieldpos

 lda playfield+47
 sta temp4
 lda playfield+46
 sta temp3
 lda playfield+45
 sta temp2
 lda playfield+44
 sta temp1

 ldx #44
down2
 lda playfield-1,x
 sta playfield+3,x
 lda playfield-2,x
 sta playfield+2,x
 lda playfield-3,x
 sta playfield+1,x
 lda playfield-4,x
 sta playfield,x
; txa
; sbx #4
 dex
 dex
 dex
 dex
 bne down2

 lda temp4
 sta playfield+3
 lda temp3
 sta playfield+2
 lda temp2
 sta playfield+1
 lda temp1
 sta playfield

noshiftdown
 RETURN
;standard routines needed for pretty much all games
; just the random number generator is left - maybe we should remove this asm file altogether?
; repositioning code and score pointer setup moved to overscan
; read switches, joysticks now compiler generated (more efficient)

randomize
	lda rand
	lsr
 ifconst rand16
	rol rand16
 endif
	bcc noeor
	eor #$B4
noeor
	sta rand
 ifconst rand16
	eor rand16
 endif
	RETURN
drawscreen
 ifconst debugscore
   ldx #14
   lda INTIM ; display # cycles left in the score

 ifconst mincycles
 lda mincycles 
 cmp INTIM
 lda mincycles
 bcc nochange
 lda INTIM
 sta mincycles
nochange
 endif

;   cmp #$2B
;   bcs no_cycles_left
   bmi cycles_left
   ldx #64
   eor #$ff ;make negative
cycles_left
   stx scorecolor
   and #$7f ; clear sign bit
   tax
   lda scorebcd,x
   sta score+2
   lda scorebcd1,x
   sta score+1
   jmp done_debugscore   
scorebcd
 .byte $00, $64, $28, $92, $56, $20, $84, $48, $12, $76, $40
 .byte $04, $68, $32, $96, $60, $24, $88, $52, $16, $80, $44
 .byte $08, $72, $36, $00, $64, $28, $92, $56, $20, $84, $48
 .byte $12, $76, $40, $04, $68, $32, $96, $60, $24, $88
scorebcd1
 .byte 0, 0, 1, 1, 2, 3, 3, 4, 5, 5, 6
 .byte 7, 7, 8, 8, 9, $10, $10, $11, $12, $12, $13
 .byte $14, $14, $15, $16, $16, $17, $17, $18, $19, $19, $20
 .byte $21, $21, $22, $23, $23, $24, $24, $25, $26, $26
done_debugscore
 endif

 ifconst debugcycles
   lda INTIM ; if we go over, it mucks up the background color
;   cmp #$2B
;   BCC overscan
   bmi overscan
   sta COLUBK
   bcs doneoverscan
 endif

overscan
 lda INTIM ;wait for sync
 bmi overscan
doneoverscan
;do VSYNC
 lda #2
 sta WSYNC
 sta VSYNC
 STA WSYNC
 STA WSYNC
 LDA #0
 STA WSYNC
 STA VSYNC
 sta VBLANK
 ifnconst overscan_time
 lda #37+128
 else
 lda #overscan_time+128
 endif
 sta TIM64T

; position player 0
 lda player0x
 beq noposP0
 ldx #0
 ldy player0y
 jsr playerset

noposP0
; position player 1
 lda player1x
 beq noposP1
 ldx #1
 ldy player1y
 jsr playerset

noposP1
; position missile 0
 lda missile0x
 beq noposM0
 ldx #2
 ldy missile0y
 jsr playerset

noposM0
; position missile 1
 lda missile1x
 beq noposM1
 ldx #3
 ldy missile1y
 jsr playerset

noposM1
; position ball
 lda ballx
 beq noposball
 ldx #4
 ldy bally
 jsr playerset

noposball
;set score pointers
 lda score+2
 jsr scorepointerset
 sty scorepointers+10
 stx scorepointers+8
 lda score+1
 jsr scorepointerset
 sty scorepointers+6
 stx scorepointers+4
 lda score
 jsr scorepointerset
 sty scorepointers+2
 stx scorepointers

vblk
; run possible vblank bB code
 ifconst vblank_bB_code
   jsr vblank_bB_code
 endif
vblk2
 LDA INTIM
 bmi vblk2
 jmp kernel

playerset ;x: 0=p0, 1=p0, 2=m0, 3=m1, 4=bl
horpos   
 sec
 sta HMCLR 
 sta WSYNC
rept
 sbc #15
 bcs rept
 eor #7   
 asl
 asl
 asl
 asl  
 sta RESP0,x
 sta HMP0,x
 sta WSYNC
 sta HMOVE
 sty objecty,x
 rts

scorepointerset
 tax
 and #$0F
 asl
 asl
 asl
 adc #<scoretable
 tay 
 txa
 and #$F0
 lsr
 adc #<scoretable
 tax
 rts
game
.L00 ;  rem           GoB! Fight for the Desert  v6a

.L01 ;  rem ----------------------------------------------------------

.L02 ;  rem    LCC 2700 Spring 06

.L03 ;  rem                        Patrick Jahn

.L04 ;  rem                        Greg Kinsey

.L05 ;  rem                        John Swisshelm

.L06 ;  rem ----------------------------------------------------------

.
 ; 

.L07 ;  rem Variables listing

.L08 ;  rem -----------------

.L09 ;  rem a -> punch

.L010 ;  rem b -> punch2

.L011 ;  rem c -> used for clearscreen

.L012 ;  rem d -> nopunch

.L013 ;  rem e -> nopunch2

.L014 ;  rem f -> used for flicker

.L015 ;  rem g -> p0death

.L016 ;  rem h -> p1death

.L017 ;  rem i -> buzz variable

.L018 ;  rem j ->

.L019 ;  rem k -> sectimer

.L020 ;  rem l -> frametimer

.L021 ;  rem m -> invincible0

.L022 ;  rem n -> invincible1

.L023 ;  rem o -> p0score

.L024 ;  rem p -> p1score

.L025 ;  rem q ->

.L026 ;  rem r -> pfadd

.L027 ;  rem s -> pfadd2

.L028 ;  rem t ->

.L029 ;  rem u ->

.L030 ;  rem v -> used for player1 x

.L031 ;  rem w -> used for player1 y

.L032 ;  rem x -> used for player0 x

.L033 ;  rem y -> used for player0 y

.L034 ;  rem z -> used for buzz 1

.
 ; 

.init
 ; init

.L035 ;  rem --- frametimer counts frames

.L036 ;  dim frametimer  =  l

.
 ; 

.L037 ;  rem --- sectimer counts seconds based on 60 frames per second

.L038 ;  dim sectimer  =  k

.
 ; 

.L039 ;  rem --- death counter for explosion and reset uses g,h

.L040 ;  dim p0death  =  g

.L041 ;  dim p1death  =  h

.
 ; 

.L042 ;  rem --- punch counters use vars a, b

.L043 ;  dim punch  =  a

.L044 ;  dim punch2  =  b

.
 ; 

.L045 ;  rem --- nopunch counter use vars d, e keeps player from continuously holding punch

.L046 ;  dim nopunch  =  d

.L047 ;  dim nopunch2  =  e

.
 ; 

.L048 ;  rem --- invincibility counter for each player for after death

.L049 ;  dim invincible0  =  m

.L050 ;  dim invincible1  =  n

.
 ; 

.L051 ;  rem --- score tracking

.L052 ;  dim p0score  =  o

.L053 ;  dim p1score  =  p

.
 ; 

.startgame
 ; startgame

.
 ; 

.L054 ;  score  =  0

	LDA #$00
	STA score+2
	LDA #$00
	STA score+1
	LDA #$00
	STA score
.L055 ;  p0score  =  0

	LDA #0
	STA p0score
.L056 ;  p1score  =  0

	LDA #0
	STA p1score
.
 ; 

.L057 ;  rem --- player starting positions

.L058 ;  x  =  70  :  y  =  70

	LDA #70
	STA x
	STA y
.L059 ;  v  =  110  :  w  =  70

	LDA #110
	STA v
	LDA #70
	STA w
.
 ; 

.L060 ;  rem ---------- PLAYFIELD SETUP

.
 ; 

.L061 ;  rem --- clear screen

.L062 ;  c  =  0

	LDA #0
	STA c
.clearscreen
 ; clearscreen

.L063 ;  pfhline 0 c 31 off

	LDA #31
	STA temp3
	LDA #0
	LDY c
	LDX #1
 jsr pfhline
.L064 ;  if c  <=  11 then c  =  c  +  1  :  goto clearscreen

	LDA #11
	CMP c
     BCC .skipL064
	INC c
 jmp .clearscreen

.skipL064
.
 ; 

.L065 ;  rem--- playfield colors tan & brown, score is white

.L066 ;  COLUPF  =  36

	LDA #36
	STA COLUPF
.L067 ;  COLUBK  =  44

	LDA #44
	STA COLUBK
.L068 ;  scorecolor  =  14

	LDA #14
	STA scorecolor
.
 ; 

.L069 ;  rem --- pfadd stores rands to add to the playfield uses q, r

.L070 ;  dim pfadd  =  r

.L071 ;  pfadd  =  10

	LDA #10
	STA pfadd
.L072 ;  dim pfadd2  =  q

.
 ; 

.L073 ;  pfvline 0 0 11

	LDA #11

	STA temp3
	LDA #0
	LDY #0
	LDX #0
 jsr pfvline
.L074 ;  pfvline 1 0 11

	LDA #11

	STA temp3
	LDA #1
	LDY #0
	LDX #0
 jsr pfvline
.L075 ;  pfvline 30 0 11

	LDA #11

	STA temp3
	LDA #30
	LDY #0
	LDX #0
 jsr pfvline
.L076 ;  pfvline 31 0 11

	LDA #11

	STA temp3
	LDA #31
	LDY #0
	LDX #0
 jsr pfvline
.L077 ;  pfpixel 2 0 on : pfpixel 29 0 on : pfpixel 2 1 on : pfpixel 3 1 on

	LDA #2
	LDY #0
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #0
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #1
	LDX #0
 jsr pfpixel
	LDA #3
	LDY #1
	LDX #0
 jsr pfpixel
.L078 ;  pfpixel 28 1 on : pfpixel 29 1 on : pfpixel 2 2 on : pfpixel 28 2 on

	LDA #28
	LDY #1
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #1
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #2
	LDX #0
 jsr pfpixel
	LDA #28
	LDY #2
	LDX #0
 jsr pfpixel
.L079 ;  pfpixel 29 2 on : pfpixel 29 3 on : pfpixel 2 4 on : pfpixel 2 5 on

	LDA #29
	LDY #2
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #3
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #5
	LDX #0
 jsr pfpixel
.L080 ;  pfpixel 3 5 on : pfpixel 2 6 on : pfpixel 29 6 on : pfpixel 28 7 on

	LDA #3
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #6
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #6
	LDX #0
 jsr pfpixel
	LDA #28
	LDY #7
	LDX #0
 jsr pfpixel
.L081 ;  pfpixel 29 7 on : pfpixel 2 8 on : pfpixel 29 8 on : pfpixel 2 9 on

	LDA #29
	LDY #7
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #8
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #8
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #9
	LDX #0
 jsr pfpixel
.L082 ;  pfpixel 3 9 on : pfpixel 2 10 on : pfpixel 3 10 on : pfpixel 29 10 on

	LDA #3
	LDY #9
	LDX #0
 jsr pfpixel
	LDA #2
	LDY #10
	LDX #0
 jsr pfpixel
	LDA #3
	LDY #10
	LDX #0
 jsr pfpixel
	LDA #29
	LDY #10
	LDX #0
 jsr pfpixel
.
 ; 

.L083 ;  rem --- vertical bar on sides

.L084 ;  PF0 = 128

	LDA #128
	STA PF0
.
 ; 

.L085 ;  sectimer  =  0

	LDA #0
	STA sectimer
.L086 ;  frametimer  =  0

	LDA #0
	STA frametimer
.
 ; 

.mainloop
 ; mainloop

.
 ; 

.L087 ;  rem --- fix bug where players get stuck on each other after death

.L088 ;  if x  =  v  &&  y  =  w then x  =  x  +  1  :  w  =  w  +  1

	LDA x
	CMP v
     BNE .skipL088
	LDA y
	CMP w
     BNE .skip1then
	INC x
	INC w
.skip1then
.skipL088
.
 ; 

.L089 ;  rem --- TIMERS

.L090 ;  frametimer  =  frametimer  +  1

	INC frametimer
.L091 ;  if frametimer  >=  60 then frametimer  =  0  :  sectimer  =  sectimer  +  1

	LDA frametimer
	CMP #60
     BCC .skipL091
	LDA #0
	STA frametimer
	INC sectimer
.skipL091
.
 ; 

.L092 ;  rem --- INVINCIBILITY DECREMENT

.L093 ;  if invincible0  >  0 then invincible0  =  invincible0  -  1

	LDA #0
	CMP invincible0
     BCS .skipL093
	DEC invincible0
.skipL093
.L094 ;  if invincible1  >  0 then invincible1  =  invincible1  -  1

	LDA #0
	CMP invincible1
     BCS .skipL094
	DEC invincible1
.skipL094
.
 ; 

.L095 ;  rem --- SCENERY CHANGE

.L096 ;  rem -- start out with 36 and 44

.L097 ;  if sectimer  =  30 then COLUPF  =  32  :  COLUBK  =  38

	LDA sectimer
	CMP #30
     BNE .skipL097
	LDA #32
	STA COLUPF
	LDA #38
	STA COLUBK
.skipL097
.L098 ;  if sectimer  =  60 then COLUPF  =  32  :  COLUBK  =  242

	LDA sectimer
	CMP #60
     BNE .skipL098
	LDA #32
	STA COLUPF
	LDA #242
	STA COLUBK
.skipL098
.L099 ;  if sectimer  =  90 then COLUPF  =  160  :  COLUBK  =  2

	LDA sectimer
	CMP #90
     BNE .skipL099
	LDA #160
	STA COLUPF
	LDA #2
	STA COLUBK
.skipL099
.L0100 ;  if sectimer  =  120 then COLUPF  =  36  :  COLUBK  =  44  :  sectimer  =  0  :  goto winsound0

	LDA sectimer
	CMP #120
     BNE .skipL0100
	LDA #36
	STA COLUPF
	LDA #44
	STA COLUBK
	LDA #0
	STA sectimer
 jmp .winsound0

.skipL0100
.
 ; 

.L0101 ;  rem --- required to stop artifacts

.L0102 ;  if playfieldpos <> 7 then skip

	LDA playfieldpos
	CMP #7
	bne .skip
.
 ; 

.L0103 ;  rem --------------------- PLAYFIELD RANDOMIZATION

.L0104 ;  rem -- random seed

.L0105 ;  rand  =  rand

 jsr randomize
	STA rand
.
 ; 

.L0106 ;  rem -- first clear out old pixels

.L0107 ;  pfhline 4 11 27 off

	LDA #27
	STA temp3
	LDA #4
	LDY #11
	LDX #1
 jsr pfhline
.
 ; 

.L0108 ;  rem -- then generate new pixels

.L0109 ;  pfadd  =  rand

 jsr randomize
	STA pfadd
.L0110 ;  if pfadd  >  92 then goto skip

	LDA #92
	CMP pfadd
     BCS .skipL0110
 jmp .skip

.skipL0110
.reduce_pfadd
 ; reduce_pfadd

.L0111 ;  if pfadd  > 23 then pfadd  =  pfadd  -  23  :  goto reduce_pfadd

	LDA #23
	CMP pfadd
     BCS .skipL0111
	LDA pfadd
	SEC
	SBC #23
	STA pfadd
 jmp .reduce_pfadd

.skipL0111
.L0112 ;  pfadd  =  pfadd  +  3

	LDA pfadd
	CLC
	ADC #3
	STA pfadd
.L0113 ;  pfpixel pfadd 11 on

	LDA pfadd
	LDY #11
	LDX #0
 jsr pfpixel
.L0114 ;  pfadd2  =  pfadd  +  1

	LDA pfadd
	CLC
	ADC #1
	STA pfadd2
.L0115 ;  pfpixel pfadd2 11 on

	LDA pfadd2
	LDY #11
	LDX #0
 jsr pfpixel
.skip
 ; skip

.
 ; 

.L0116 ;  pfscroll down

	LDA #4
 jsr pfscroll
.
 ; 

.L0117 ;  rem ---- INVINCIBILITY CHECK and PLAYER COLOR

.L0118 ;  if invincible0  >  0 then COLUP0  =  12 else COLUP0  =  68

	LDA #0
	CMP invincible0
     BCS .skipL0118
	LDA #12
	STA COLUP0
 jmp .skipelse0
.skipL0118
	LDA #68
	STA COLUP0
.skipelse0
.L0119 ;  if invincible1  >  0 then COLUP1  =  12 else COLUP1  =  132

	LDA #0
	CMP invincible1
     BCS .skipL0119
	LDA #12
	STA COLUP1
 jmp .skipelse1
.skipL0119
	LDA #132
	STA COLUP1
.skipelse1
.
 ; 

.L0120 ;  rem ------------------------------------------------ PLAYER0

.
 ; 

.L0121 ;  rem ----------------- death sprites

.L0122 ;  if p0death  >  10 then goto death0a

	LDA #10
	CMP p0death
     BCS .skipL0122
 jmp .death0a

.skipL0122
.L0123 ;  if p0death  >  5 then goto death0b

	LDA #5
	CMP p0death
     BCS .skipL0123
 jmp .death0b

.skipL0123
.L0124 ;  if p0death  >  0 then goto death0c

	LDA #0
	CMP p0death
     BCS .skipL0124
 jmp .death0c

.skipL0124
.
 ; 

.L0125 ;  rem ----------------- punch sprites

.L0126 ;  rem --- if 0 < punch <= 5 then left punch

.L0127 ;  rem --- if 5 < punch <= 10 then right punch

.L0128 ;  if punch  >  0  &&  punch  <=  5 then goto leftpunch

	LDA #0
	CMP punch
     BCS .skipL0128
	LDA #5
	CMP punch
     BCC .skip17then
 jmp .leftpunch

.skip17then
.skipL0128
.L0129 ;  if punch  >  5 then goto rightpunch

	LDA #5
	CMP punch
     BCS .skipL0129
 jmp .rightpunch

.skipL0129
.L0130 ;  rem --- if it makes it here, punch = 0

.L0131 ;  rem --- everytime you punch, it will set nopunch to five. The loop will not let you punch until it is back to zero

.L0132 ;  if nopunch  >  0 then nopunch  =  nopunch  -  1

	LDA #0
	CMP nopunch
     BCS .skipL0132
	DEC nopunch
.skipL0132
.L0133 ;  if nopunch  >  0 then goto normal

	LDA #0
	CMP nopunch
     BCS .skipL0133
 jmp .normal

.skipL0133
.L0134 ;  if joy0left  &&  joy0fire then punch  =  0  :  goto leftpunch

 lda #$40
 bit SWCHA
	BNE .skipL0134
 lda #$80
 bit INPT4
	BNE .skip22then
	LDA #0
	STA punch
 jmp .leftpunch

.skip22then
.skipL0134
.L0135 ;  if joy0right  &&  joy0fire then punch  =  6  :  goto rightpunch

 lda #$80
 bit SWCHA
	BNE .skipL0135
 lda #$80
 bit INPT4
	BNE .skip24then
	LDA #6
	STA punch
 jmp .rightpunch

.skip24then
.skipL0135
.L0136 ;  rem if joy0fire then goto rightpunch

.
 ; 

.normal
 ; normal

.L0137 ;  rem ----------------- normal sprites

.L0138 ;  if joy0left  &&  f  =  2 then goto leftflicker

 lda #$40
 bit SWCHA
	BNE .skipL0138
	LDA f
	CMP #2
     BNE .skip26then
 jmp .leftflicker

.skip26then
.skipL0138
.L0139 ;  if joy0right  &&  f  =  2 then goto rightflicker

 lda #$80
 bit SWCHA
	BNE .skipL0139
	LDA f
	CMP #2
     BNE .skip28then
 jmp .rightflicker

.skip28then
.skipL0139
.
 ; 

.L0140 ;  if f  =  2 then goto flicker

	LDA f
	CMP #2
     BNE .skipL0140
 jmp .flicker

.skipL0140
.
 ; 

.L0141 ;  if joy0left then goto left

 lda #$40
 bit SWCHA
	BNE .skipL0141
 jmp .left

.skipL0141
.L0142 ;  if joy0right then goto right

 lda #$80
 bit SWCHA
	BNE .skipL0142
 jmp .right

.skipL0142
.
 ; 

.L0143 ;  player0:

	LDA #<playerL0143_0

	STA player0pointerlo
	LDA #>playerL0143_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0144 ;  goto player1

 jmp .player1

.
 ; 

.flicker
 ; flicker

.L0145 ;  player0: 

	LDA #<playerL0145_0

	STA player0pointerlo
	LDA #>playerL0145_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0146 ;  goto player1

 jmp .player1

.
 ; 

.left
 ; left

.L0147 ;  player0:

	LDA #<playerL0147_0

	STA player0pointerlo
	LDA #>playerL0147_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0148 ;  goto player1

 jmp .player1

.
 ; 

.leftflicker
 ; leftflicker

.L0149 ;  player0:

	LDA #<playerL0149_0

	STA player0pointerlo
	LDA #>playerL0149_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0150 ;  goto player1

 jmp .player1

.
 ; 

.right
 ; right

.L0151 ;  player0:

	LDA #<playerL0151_0

	STA player0pointerlo
	LDA #>playerL0151_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0152 ;  goto player1

 jmp .player1

.
 ; 

.rightflicker
 ; rightflicker

.L0153 ;  player0:

	LDA #<playerL0153_0

	STA player0pointerlo
	LDA #>playerL0153_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0154 ;  goto player1

 jmp .player1

.
 ; 

.leftpunch
 ; leftpunch

.L0155 ;  if f  =  2 then goto leftpunchflicker

	LDA f
	CMP #2
     BNE .skipL0155
 jmp .leftpunchflicker

.skipL0155
.L0156 ;  player0:

	LDA #<playerL0156_0

	STA player0pointerlo
	LDA #>playerL0156_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0157 ;  if punch  =  5 then punch  =  0  :  nopunch  =  15 else punch  =  punch  +  1

	LDA punch
	CMP #5
     BNE .skipL0157
	LDA #0
	STA punch
	LDA #15
	STA nopunch
 jmp .skipelse2
.skipL0157
	INC punch
.skipelse2
.L0158 ;  goto player1

 jmp .player1

.
 ; 

.leftpunchflicker
 ; leftpunchflicker

.L0159 ;  player0:

	LDA #<playerL0159_0

	STA player0pointerlo
	LDA #>playerL0159_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0160 ;  if punch  =  5 then punch  =  0  :  nopunch  =  15 else punch  =  punch  +  1

	LDA punch
	CMP #5
     BNE .skipL0160
	LDA #0
	STA punch
	LDA #15
	STA nopunch
 jmp .skipelse3
.skipL0160
	INC punch
.skipelse3
.L0161 ;  goto player1

 jmp .player1

.
 ; 

.rightpunch
 ; rightpunch

.L0162 ;  if f  =  2 then goto rightpunchflicker

	LDA f
	CMP #2
     BNE .skipL0162
 jmp .rightpunchflicker

.skipL0162
.L0163 ;  player0:

	LDA #<playerL0163_0

	STA player0pointerlo
	LDA #>playerL0163_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0164 ;  if punch  =  10 then punch  =  0  :  nopunch  =  15 else punch  =  punch  +  1

	LDA punch
	CMP #10
     BNE .skipL0164
	LDA #0
	STA punch
	LDA #15
	STA nopunch
 jmp .skipelse4
.skipL0164
	INC punch
.skipelse4
.L0165 ;  goto player1

 jmp .player1

.
 ; 

.rightpunchflicker
 ; rightpunchflicker

.L0166 ;  player0:

	LDA #<playerL0166_0

	STA player0pointerlo
	LDA #>playerL0166_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0167 ;  if punch  =  10 then punch  =  0  :  nopunch  =  15 else punch  =  punch  +  1

	LDA punch
	CMP #10
     BNE .skipL0167
	LDA #0
	STA punch
	LDA #15
	STA nopunch
 jmp .skipelse5
.skipL0167
	INC punch
.skipelse5
.L0168 ;  goto player1

 jmp .player1

.
 ; 

.death0a
 ; death0a

.L0169 ;  player0:

	LDA #<playerL0169_0

	STA player0pointerlo
	LDA #>playerL0169_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0170 ;  p0death  =  p0death  -  1

	DEC p0death
.L0171 ;  goto buzz

 jmp .buzz

.
 ; 

.death0b
 ; death0b

.L0172 ;  player0:

	LDA #<playerL0172_0

	STA player0pointerlo
	LDA #>playerL0172_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0173 ;  p0death  =  p0death  -  1

	DEC p0death
.L0174 ;  goto player1

 jmp .player1

.
 ; 

.death0c
 ; death0c

.L0175 ;  player0:

	LDA #<playerL0175_0

	STA player0pointerlo
	LDA #>playerL0175_0

	STA player0pointerhi
	LDA #15
	STA player0height
.L0176 ;  p0death  =  p0death  -  1

	DEC p0death
.L0177 ;  rem --- PLAYER0 DEATH ------------

.L0178 ;  rem reset player0, enable invincibility, increase player1's score

.L0179 ;  if p0death  =  0 then x  =  70  :  y  =  70  :  invincible0  =  45  :  p1score  =  p1score  +  1  :  score  =  score  +  1

	LDA p0death
	CMP #0
     BNE .skipL0179
	LDA #70
	STA x
	STA y
	LDA #45
	STA invincible0
	INC p1score
	SED
	CLC
	LDA score+2
	ADC #$01
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$00
	STA score
	CLD
.skipL0179
.L0180 ;  goto player1

 jmp .player1

.
 ; 

.
 ; 

.
 ; 

.
 ; 

.player1
 ; player1

.L0181 ;  rem ------------------------------------------- PLAYER 1

.
 ; 

.L0182 ;  rem ----------------- death sprites

.L0183 ;  if p1death  >  10 then goto death1a

	LDA #10
	CMP p1death
     BCS .skipL0183
 jmp .death1a

.skipL0183
.L0184 ;  if p1death  >  5 then goto death1b

	LDA #5
	CMP p1death
     BCS .skipL0184
 jmp .death1b

.skipL0184
.L0185 ;  if p1death  >  0 then goto death1c

	LDA #0
	CMP p1death
     BCS .skipL0185
 jmp .death1c

.skipL0185
.
 ; 

.L0186 ;  rem ----------------- punch sprites

.L0187 ;  rem --- if 0 < punch2 <= 5 then left punch2

.L0188 ;  rem --- if 5 < punch2 <= 10 then right punch2

.L0189 ;  if punch2  >  0  &&  punch2  <=  5 then goto leftpunch2

	LDA #0
	CMP punch2
     BCS .skipL0189
	LDA #5
	CMP punch2
     BCC .skip43then
 jmp .leftpunch2

.skip43then
.skipL0189
.L0190 ;  if punch2  >  5 then goto rightpunch2

	LDA #5
	CMP punch2
     BCS .skipL0190
 jmp .rightpunch2

.skipL0190
.L0191 ;  rem --- if it makes it here, punch2 = 0

.L0192 ;  rem --- everytime you punch, it will set nopunch2 to five. The loop will not let you punch until it is back to zero

.L0193 ;  if nopunch2  >  0 then nopunch2  =  nopunch2  -  1

	LDA #0
	CMP nopunch2
     BCS .skipL0193
	DEC nopunch2
.skipL0193
.L0194 ;  if nopunch2  >  0 then goto normal2

	LDA #0
	CMP nopunch2
     BCS .skipL0194
 jmp .normal2

.skipL0194
.L0195 ;  if joy1left  &&  joy1fire then punch2  =  0  :  goto leftpunch2

 lda #4
 bit SWCHA
	BNE .skipL0195
 lda #$80
 bit INPT5
	BNE .skip48then
	LDA #0
	STA punch2
 jmp .leftpunch2

.skip48then
.skipL0195
.L0196 ;  if joy1right  &&  joy1fire then punch2  =  6  :  goto rightpunch2

 lda #8
 bit SWCHA
	BNE .skipL0196
 lda #$80
 bit INPT5
	BNE .skip50then
	LDA #6
	STA punch2
 jmp .rightpunch2

.skip50then
.skipL0196
.L0197 ;  rem if joy1fire then goto rightpunch2

.
 ; 

.normal2
 ; normal2

.L0198 ;  rem ----------------- normal sprites

.L0199 ;  if joy1left  &&  f  =  2 then goto leftflicker2

 lda #4
 bit SWCHA
	BNE .skipL0199
	LDA f
	CMP #2
     BNE .skip52then
 jmp .leftflicker2

.skip52then
.skipL0199
.L0200 ;  if joy1right  &&  f  =  2 then goto rightflicker2

 lda #8
 bit SWCHA
	BNE .skipL0200
	LDA f
	CMP #2
     BNE .skip54then
 jmp .rightflicker2

.skip54then
.skipL0200
.
 ; 

.L0201 ;  if f  =  2 then goto flicker2

	LDA f
	CMP #2
     BNE .skipL0201
 jmp .flicker2

.skipL0201
.
 ; 

.L0202 ;  if joy1left then goto left2

 lda #4
 bit SWCHA
	BNE .skipL0202
 jmp .left2

.skipL0202
.L0203 ;  if joy1right then goto right2

 lda #8
 bit SWCHA
	BNE .skipL0203
 jmp .right2

.skipL0203
.
 ; 

.L0204 ;  player1:

	LDA #<playerL0204_1

	STA player1pointerlo
	LDA #>playerL0204_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0205 ;  f  =  f  +  1

	INC f
.L0206 ;  goto paint

 jmp .paint

.
 ; 

.flicker2
 ; flicker2

.L0207 ;  player1: 

	LDA #<playerL0207_1

	STA player1pointerlo
	LDA #>playerL0207_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0208 ;  f  =  0

	LDA #0
	STA f
.L0209 ;  goto paint

 jmp .paint

.
 ; 

.left2
 ; left2

.L0210 ;  player1:

	LDA #<playerL0210_1

	STA player1pointerlo
	LDA #>playerL0210_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0211 ;  f  =  f  +  1

	INC f
.L0212 ;  goto paint

 jmp .paint

.
 ; 

.leftflicker2
 ; leftflicker2

.L0213 ;  player1:

	LDA #<playerL0213_1

	STA player1pointerlo
	LDA #>playerL0213_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0214 ;  f  =  0

	LDA #0
	STA f
.L0215 ;  goto paint

 jmp .paint

.
 ; 

.right2
 ; right2

.L0216 ;  player1:

	LDA #<playerL0216_1

	STA player1pointerlo
	LDA #>playerL0216_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0217 ;  f  =  f  +  1

	INC f
.L0218 ;  goto paint

 jmp .paint

.
 ; 

.rightflicker2
 ; rightflicker2

.L0219 ;  player1:

	LDA #<playerL0219_1

	STA player1pointerlo
	LDA #>playerL0219_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0220 ;  f  =  0

	LDA #0
	STA f
.L0221 ;  goto paint

 jmp .paint

.
 ; 

.leftpunch2
 ; leftpunch2

.L0222 ;  if f  =  2 then goto leftpunchflicker2

	LDA f
	CMP #2
     BNE .skipL0222
 jmp .leftpunchflicker2

.skipL0222
.L0223 ;  player1:

	LDA #<playerL0223_1

	STA player1pointerlo
	LDA #>playerL0223_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0224 ;  f  =  f  +  1

	INC f
.L0225 ;  if punch2  =  5 then punch2  =  0  :  nopunch2  =  15 else punch2  =  punch2  +  1

	LDA punch2
	CMP #5
     BNE .skipL0225
	LDA #0
	STA punch2
	LDA #15
	STA nopunch2
 jmp .skipelse6
.skipL0225
	INC punch2
.skipelse6
.L0226 ;  goto paint

 jmp .paint

.
 ; 

.leftpunchflicker2
 ; leftpunchflicker2

.L0227 ;  player1:

	LDA #<playerL0227_1

	STA player1pointerlo
	LDA #>playerL0227_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0228 ;  f  =  0

	LDA #0
	STA f
.L0229 ;  if punch2  =  5 then punch2  =  0  :  nopunch2  =  15 else punch2  =  punch2  +  1

	LDA punch2
	CMP #5
     BNE .skipL0229
	LDA #0
	STA punch2
	LDA #15
	STA nopunch2
 jmp .skipelse7
.skipL0229
	INC punch2
.skipelse7
.L0230 ;  goto paint

 jmp .paint

.
 ; 

.rightpunch2
 ; rightpunch2

.L0231 ;  if f  =  2 then goto rightpunchflicker2

	LDA f
	CMP #2
     BNE .skipL0231
 jmp .rightpunchflicker2

.skipL0231
.L0232 ;  player1:

	LDA #<playerL0232_1

	STA player1pointerlo
	LDA #>playerL0232_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0233 ;  f  =  f  +  1

	INC f
.L0234 ;  if punch2  =  10 then punch2  =  0  :  nopunch2  =  15 else punch2  =  punch2  +  1

	LDA punch2
	CMP #10
     BNE .skipL0234
	LDA #0
	STA punch2
	LDA #15
	STA nopunch2
 jmp .skipelse8
.skipL0234
	INC punch2
.skipelse8
.L0235 ;  goto paint

 jmp .paint

.
 ; 

.rightpunchflicker2
 ; rightpunchflicker2

.L0236 ;  player1:

	LDA #<playerL0236_1

	STA player1pointerlo
	LDA #>playerL0236_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0237 ;  f  =  0

	LDA #0
	STA f
.L0238 ;  if punch2  =  10 then punch2  =  0  :  nopunch2  =  15 else punch2  =  punch2  +  1

	LDA punch2
	CMP #10
     BNE .skipL0238
	LDA #0
	STA punch2
	LDA #15
	STA nopunch2
 jmp .skipelse9
.skipL0238
	INC punch2
.skipelse9
.L0239 ;  goto paint

 jmp .paint

.
 ; 

.death1a
 ; death1a

.L0240 ;  player1:

	LDA #<playerL0240_1

	STA player1pointerlo
	LDA #>playerL0240_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0241 ;  p1death  =  p1death  -  1

	DEC p1death
.L0242 ;  goto buzz1

 jmp .buzz1

.
 ; 

.death1b
 ; death1b

.L0243 ;  player1:

	LDA #<playerL0243_1

	STA player1pointerlo
	LDA #>playerL0243_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0244 ;  p1death  =  p1death  -  1

	DEC p1death
.L0245 ;  goto paint

 jmp .paint

.
 ; 

.death1c
 ; death1c

.L0246 ;  player1:

	LDA #<playerL0246_1

	STA player1pointerlo
	LDA #>playerL0246_1

	STA player1pointerhi
	LDA #15
	STA player1height
.L0247 ;  p1death  =  p1death  -  1

	DEC p1death
.L0248 ;  rem --- PLAYER1 DEATH ------------

.L0249 ;  rem reset player1, enable invincibility, increase player0's score

.L0250 ;  if p1death  =  0 then v  =  110  :  w  =  70  :  invincible1  =  45  :  p0score  =  p0score  +  1  :  score  =  score  +  10000

	LDA p1death
	CMP #0
     BNE .skipL0250
	LDA #110
	STA v
	LDA #70
	STA w
	LDA #45
	STA invincible1
	INC p0score
	SED
	CLC
	LDA score+2
	ADC #$00
	STA score+2
	LDA score+1
	ADC #$00
	STA score+1
	LDA score
	ADC #$01
	STA score
	CLD
.skipL0250
.L0251 ;  goto paint

 jmp .paint

.
 ; 

.
 ; 

.L0252 ;  rem ------------------------ PAINT

.paint
 ; paint

.L0253 ;  goto puttsound

 jmp .puttsound

.backtopaint
 ; backtopaint

.L0254 ;  rem --------- player 0 x,y = x,y  player 1 x,y = v,w

.L0255 ;  player0x  =  x  :  player0y  =  y

	LDA x
	STA player0x
	LDA y
	STA player0y
.L0256 ;  player1x  =  v  :  player1y  =  w

	LDA v
	STA player1x
	LDA w
	STA player1y
.L0257 ;  drawscreen

 jsr drawscreen
.
 ; 

.L0258 ;  if switchreset then goto startgame

 lda #1
 bit SWCHB
	BNE .skipL0258
 jmp .startgame

.skipL0258
.
 ; 

.L0259 ;  if collision(player0,playfield)  &&  invincible0  =  0 then goto fieldcollision0

	BIT CXP0FB
	BPL .skipL0259
	LDA invincible0
	CMP #0
     BNE .skip67then
 jmp .fieldcollision0

.skip67then
.skipL0259
.L0260 ;  if collision(player1,playfield)  &&  invincible1  =  0 then goto fieldcollision1

	BIT CXP1FB
	BPL .skipL0260
	LDA invincible1
	CMP #0
     BNE .skip69then
 jmp .fieldcollision1

.skip69then
.skipL0260
.L0261 ;  if collision(player0,player1) then goto playercollision

	BIT CXPPMM
	BPL .skipL0261
 jmp .playercollision

.skipL0261
.
 ; 

.
 ; 

.freemovep0
 ; freemovep0

.L0262 ;  if joy0left then x  =  x  -  1

 lda #$40
 bit SWCHA
	BNE .skipL0262
	DEC x
.skipL0262
.L0263 ;  if joy0right then x  =  x  +  1

 lda #$80
 bit SWCHA
	BNE .skipL0263
	INC x
.skipL0263
.L0264 ;  if joy0up then y  =  y  -  1

 lda #$10
 bit SWCHA
	BNE .skipL0264
	DEC y
.skipL0264
.L0265 ;  if joy0down then y  =  y  +  1

 lda #$20
 bit SWCHA
	BNE .skipL0265
	INC y
.skipL0265
.
 ; 

.L0266 ;  if p1death  >  0 then goto bounds

	LDA #0
	CMP p1death
     BCS .skipL0266
 jmp .bounds

.skipL0266
.
 ; 

.freemovep1
 ; freemovep1

.L0267 ;  if joy1left then v  =  v  -  1

 lda #4
 bit SWCHA
	BNE .skipL0267
	DEC v
.skipL0267
.L0268 ;  if joy1right then v  =  v  +  1

 lda #8
 bit SWCHA
	BNE .skipL0268
	INC v
.skipL0268
.L0269 ;  if joy1up then w  =  w  -  1

 lda #1
 bit SWCHA
	BNE .skipL0269
	DEC w
.skipL0269
.L0270 ;  if joy1down then w  =  w  +  1

 lda #2
 bit SWCHA
	BNE .skipL0270
	INC w
.skipL0270
.
 ; 

.L0271 ;  goto bounds

 jmp .bounds

.
 ; 

.playercollision
 ; playercollision

.L0272 ;  rem --- player0 is left of player1

.L0273 ;  if x  <  v then x  =  x  -  1  :  v  =  v  +  1

	LDA x
	CMP v
     BCS .skipL0273
	DEC x
	INC v
.skipL0273
.L0274 ;  rem ------- player0 punches right

.L0275 ;  if x  <  v  &&  punch  >  5 then v  =  v  +  15  :  goto punchsound

	LDA x
	CMP v
     BCS .skipL0275
	LDA #5
	CMP punch
     BCS .skip82then
	LDA v
	CLC
	ADC #15
	STA v
 jmp .punchsound

.skip82then
.skipL0275
.L0276 ;  rem ------- player1 punches left

.L0277 ;  if x  <  v  &&  punch2  >  0 then x  =  x  -  15  :  goto punchsound

	LDA x
	CMP v
     BCS .skipL0277
	LDA #0
	CMP punch2
     BCS .skip84then
	LDA x
	SEC
	SBC #15
	STA x
 jmp .punchsound

.skip84then
.skipL0277
.
 ; 

.L0278 ;  rem --- player0 is right of player1

.L0279 ;  if x  >  v then x  =  x  +  1  :  v  =  v  -  1

	LDA v
	CMP x
     BCS .skipL0279
	INC x
	DEC v
.skipL0279
.L0280 ;  rem ------- player0 punches left

.L0281 ;  if x  >  v  &&  punch  >  0 then v  =  v  -  15  :  goto punchsound

	LDA v
	CMP x
     BCS .skipL0281
	LDA #0
	CMP punch
     BCS .skip87then
	LDA v
	SEC
	SBC #15
	STA v
 jmp .punchsound

.skip87then
.skipL0281
.L0282 ;  rem ------- player1 punches right

.L0283 ;  if x  >  v  &&  punch2  >  5 then x  =  x  +  15  :  goto punchsound

	LDA v
	CMP x
     BCS .skipL0283
	LDA #5
	CMP punch2
     BCS .skip89then
	LDA x
	CLC
	ADC #15
	STA x
 jmp .punchsound

.skip89then
.skipL0283
.
 ; 

.L0284 ;  rem --- player0 is top of player1

.L0285 ;  if y  <  w then y  =  y  -  1  :  w  =  w  +  1

	LDA y
	CMP w
     BCS .skipL0285
	DEC y
	INC w
.skipL0285
.
 ; 

.L0286 ;  rem --- player0 is bottom of player1

.L0287 ;  if y  >  w then y  =  y  +  1  :  w  =  w  -  1

	LDA w
	CMP y
     BCS .skipL0287
	INC y
	DEC w
.skipL0287
.
 ; 

.L0288 ;  goto bounds

 jmp .bounds

.
 ; 

.fieldcollision0
 ; fieldcollision0

.L0289 ;  rem --- player0 hits wall and dies!

.L0290 ;  if p0death  =  0 then p0death  =  15

	LDA p0death
	CMP #0
     BNE .skipL0290
	LDA #15
	STA p0death
.skipL0290
.L0291 ;  goto freemovep1

 jmp .freemovep1

.
 ; 

.fieldcollision1
 ; fieldcollision1

.L0292 ;  rem --- player1 hits wall and dies!

.L0293 ;  if p1death  =  0 then p1death  =  15

	LDA p1death
	CMP #0
     BNE .skipL0293
	LDA #15
	STA p1death
.skipL0293
.L0294 ;  goto freemovep0

 jmp .freemovep0

.
 ; 

.bounds
 ; bounds

.L0295 ;  rem --- keep the players within bounds!

.L0296 ;  rem --- top bound

.L0297 ;  if y  <  16 then y  =  16

	LDA y
	CMP #16
     BCS .skipL0297
	LDA #16
	STA y
.skipL0297
.L0298 ;  if w  <  16 then w  =  16

	LDA w
	CMP #16
     BCS .skipL0298
	LDA #16
	STA w
.skipL0298
.L0299 ;  rem --- bottom bound

.L0300 ;  if y  >  88 then y  =  88

	LDA #88
	CMP y
     BCS .skipL0300
	LDA #88
	STA y
.skipL0300
.L0301 ;  if w  >  88 then w  =  88

	LDA #88
	CMP w
     BCS .skipL0301
	LDA #88
	STA w
.skipL0301
.L0302 ;  rem --- left and right bounds might not be needed!

.L0303 ;  rem --- left bound

.L0304 ;  if x  <  30 then x  =  30

	LDA x
	CMP #30
     BCS .skipL0304
	LDA #30
	STA x
.skipL0304
.L0305 ;  if v  <  30 then v  =  30

	LDA v
	CMP #30
     BCS .skipL0305
	LDA #30
	STA v
.skipL0305
.L0306 ;  rem --- right bound

.L0307 ;  if x  >  152 then x  =  152

	LDA #152
	CMP x
     BCS .skipL0307
	LDA #152
	STA x
.skipL0307
.L0308 ;  if v  >  152 then v  =  152

	LDA #152
	CMP v
     BCS .skipL0308
	LDA #152
	STA v
.skipL0308
.
 ; 

.L0309 ;  goto mainloop

 jmp .mainloop

.
 ; 

.L0310 ;  rem ------------------------------------------ GAME OVER

.finishgame
 ; finishgame

.L0311 ;  rem --- clear screen

.L0312 ;  c  =  0

	LDA #0
	STA c
.clearscreen2
 ; clearscreen2

.L0313 ;  pfhline 0 c 31 off

	LDA #31
	STA temp3
	LDA #0
	LDY c
	LDX #1
 jsr pfhline
.L0314 ;  if c  <=  11 then c  =  c  +  1  :  goto clearscreen2

	LDA #11
	CMP c
     BCC .skipL0314
	INC c
 jmp .clearscreen2

.skipL0314
.
 ; 

.L0315 ;  pfpixel 11 4 on : pfpixel 17 4 on : pfpixel 19 4 on : pfpixel 21 4 on

	LDA #11
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #17
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #19
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #21
	LDY #4
	LDX #0
 jsr pfpixel
.L0316 ;  pfpixel 22 4 on : pfpixel 24 4 on : pfpixel 12 5 on : pfpixel 14 5 on

	LDA #22
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #24
	LDY #4
	LDX #0
 jsr pfpixel
	LDA #12
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #14
	LDY #5
	LDX #0
 jsr pfpixel
.L0317 ;  pfpixel 16 5 on : pfpixel 19 5 on : pfpixel 21 5 on : pfpixel 23 5 on

	LDA #16
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #19
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #21
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #23
	LDY #5
	LDX #0
 jsr pfpixel
.L0318 ;  pfpixel 24 5 on : pfpixel 13 6 on : pfpixel 15 6 on : pfpixel 19 6 on

	LDA #24
	LDY #5
	LDX #0
 jsr pfpixel
	LDA #13
	LDY #6
	LDX #0
 jsr pfpixel
	LDA #15
	LDY #6
	LDX #0
 jsr pfpixel
	LDA #19
	LDY #6
	LDX #0
 jsr pfpixel
.L0319 ;  pfpixel 21 6 on : pfpixel 24 6 on

	LDA #21
	LDY #6
	LDX #0
 jsr pfpixel
	LDA #24
	LDY #6
	LDX #0
 jsr pfpixel
.
 ; 

.L0320 ;  if p0score  >  p1score then goto p0wins

	LDA p1score
	CMP p0score
     BCS .skipL0320
 jmp .p0wins

.skipL0320
.L0321 ;  if p0score  <  p1score then goto p1wins

	LDA p0score
	CMP p1score
     BCS .skipL0321
 jmp .p1wins

.skipL0321
.L0322 ;  goto tie

 jmp .tie

.
 ; 

.p0wins
 ; p0wins

.L0323 ;  COLUP0  =  68

	LDA #68
	STA COLUP0
.L0324 ;  COLUP1  =  44

	LDA #44
	STA COLUP1
.L0325 ;  player0x  =  60  :  player0y  =  51

	LDA #60
	STA player0x
	LDA #51
	STA player0y
.L0326 ;  player1x  =  110  :  player1y  =  70

	LDA #110
	STA player1x
	LDA #70
	STA player1y
.L0327 ;  drawscreen

 jsr drawscreen
.L0328 ;  if switchreset then goto startgame else goto p0wins

 lda #1
 bit SWCHB
	BNE .skipL0328
 jmp .startgame
 jmp .skipelse10
.skipL0328
 jmp .p0wins

.skipelse10
.
 ; 

.p1wins
 ; p1wins

.L0329 ;  COLUP0  =  44

	LDA #44
	STA COLUP0
.L0330 ;  COLUP1  =  132

	LDA #132
	STA COLUP1
.L0331 ;  player0x  =  110  :  player0y  =  70

	LDA #110
	STA player0x
	LDA #70
	STA player0y
.L0332 ;  player1x  =  60  :  player1y  =  51

	LDA #60
	STA player1x
	LDA #51
	STA player1y
.L0333 ;  drawscreen

 jsr drawscreen
.L0334 ;  if switchreset then goto startgame else goto p1wins

 lda #1
 bit SWCHB
	BNE .skipL0334
 jmp .startgame
 jmp .skipelse11
.skipL0334
 jmp .p1wins

.skipelse11
.
 ; 

.tie
 ; tie

.L0335 ;  COLUP0  =  68

	LDA #68
	STA COLUP0
.L0336 ;  COLUP1  =  132

	LDA #132
	STA COLUP1
.L0337 ;  player0x  =  55  :  player0y  =  51

	LDA #55
	STA player0x
	LDA #51
	STA player0y
.L0338 ;  player1x  =  65  :  player1y  =  51

	LDA #65
	STA player1x
	LDA #51
	STA player1y
.L0339 ;  drawscreen

 jsr drawscreen
.L0340 ;  if switchreset then goto startgame else goto tie

 lda #1
 bit SWCHB
	BNE .skipL0340
 jmp .startgame
 jmp .skipelse12
.skipL0340
 jmp .tie

.skipelse12
.
 ; 

.buzz
 ; buzz

.L0341 ;  AUDV1  =  15

	LDA #15
	STA AUDV1
.L0342 ;  AUDC1  =  12

	LDA #12
	STA AUDC1
.L0343 ;  AUDF1  =  28

	LDA #28
	STA AUDF1
.L0344 ;  z  =  z  +  1

	INC z
.L0345 ;  if z  <  100 then buzz

	LDA z
	CMP #100
	bcc .buzz
.L0346 ;  AUDC1  =  0

	LDA #0
	STA AUDC1
.L0347 ;  z  =  0

	LDA #0
	STA z
.L0348 ;  goto player1

 jmp .player1

.
 ; 

.buzz1
 ; buzz1

.L0349 ;  AUDV1  =  15

	LDA #15
	STA AUDV1
.L0350 ;  AUDC1  =  12

	LDA #12
	STA AUDC1
.L0351 ;  AUDF1  =  27

	LDA #27
	STA AUDF1
.buzz1helper
 ; buzz1helper

.L0352 ;  z  =  z  +  1

	INC z
.L0353 ;  if z  < 100 then buzz1helper

	LDA z
	CMP #100
	bcc .buzz1helper
.L0354 ;  AUDC1  =  0

	LDA #0
	STA AUDC1
.L0355 ;  z  =  0

	LDA #0
	STA z
.L0356 ;  goto paint

 jmp .paint

.
 ; 

.puttsound
 ; puttsound

.L0357 ;  AUDV1  =  3

	LDA #3
	STA AUDV1
.L0358 ;  AUDC1  =  7

	LDA #7
	STA AUDC1
.L0359 ;  AUDF1  =  31

	LDA #31
	STA AUDF1
.L0360 ;  z  =  z  +  1

	INC z
.L0361 ;  if z  <  50 then puttsound

	LDA z
	CMP #50
	bcc .puttsound
.L0362 ;  AUDC1  =  0

	LDA #0
	STA AUDC1
.L0363 ;  z  =  0

	LDA #0
	STA z
.L0364 ;  goto backtopaint

 jmp .backtopaint

.
 ; 

.punchsound
 ; punchsound

.L0365 ;  AUDV1  =  15

	LDA #15
	STA AUDV1
.L0366 ;  AUDC1  =  3

	LDA #3
	STA AUDC1
.L0367 ;  AUDF1  =  31

	LDA #31
	STA AUDF1
.L0368 ;  z  =  z  +  1

	INC z
.L0369 ;  if z  <  100 then punchsound

	LDA z
	CMP #100
	bcc .punchsound
.L0370 ;  AUDC1  =  0

	LDA #0
	STA AUDC1
.L0371 ;  z  =  0

	LDA #0
	STA z
.L0372 ;  goto bounds

 jmp .bounds

.
 ; 

.winsound0
 ; winsound0

.L0373 ;  AUDV1  =  10

	LDA #10
	STA AUDV1
.L0374 ;  AUDC1  =  12

	LDA #12
	STA AUDC1
.L0375 ;  AUDF1  =  12

	LDA #12
	STA AUDF1
.L0376 ;  frametimer  =  frametimer  +  1

	INC frametimer
.L0377 ;  if frametimer  =  60 then sectimer  =  sectimer  +  1

	LDA frametimer
	CMP #60
     BNE .skipL0377
	INC sectimer
.skipL0377
.L0378 ;  if sectimer  <  10 then winsound0

	LDA sectimer
	CMP #10
	bcc .winsound0
.winsound1
 ; winsound1

.L0379 ;  AUDF1  =  6

	LDA #6
	STA AUDF1
.L0380 ;  frametimer  =  frametimer  +  1

	INC frametimer
.L0381 ;  if frametimer  =  60 then sectimer  =  sectimer  +  1

	LDA frametimer
	CMP #60
     BNE .skipL0381
	INC sectimer
.skipL0381
.L0382 ;  if sectimer  <  20 then winsound1

	LDA sectimer
	CMP #20
	bcc .winsound1
.L0383 ;  AUDC1  =  0

	LDA #0
	STA AUDC1
.L0384 ;  z  =  0

	LDA #0
	STA z
.L0385 ;  goto finishgame
 jmp .finishgame
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0143_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %01011010
	.byte  %01011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0145_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %01011010
	.byte  %01011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0147_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01101100
	.byte  %01110010
	.byte  %01110010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0149_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01101100
	.byte  %01110010
	.byte  %01110010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0151_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %00110110
	.byte  %01001110
	.byte  %01001110
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0153_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %00110110
	.byte  %01001110
	.byte  %01001110
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0156_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %11100110
	.byte  %00011010
	.byte  %00011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0159_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %11100110
	.byte  %00011010
	.byte  %00011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0163_0

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100111
	.byte  %01011000
	.byte  %01011000
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0166_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100111
	.byte  %01011000
	.byte  %01011000
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0169_0

	.byte 0
	.byte  %00001100
	.byte  %00001100
	.byte  %01001101
	.byte  %00011000
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %11000100
	.byte  %11000010
	.byte  %00100100
	.byte  %00110000
	.byte  %00110000
	.byte  %00110000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0172_0

	.byte 0
	.byte  %00010000
	.byte  %01000010
	.byte  %00011000
	.byte  %00100100
	.byte  %01000010
	.byte  %10011001
	.byte  %01000010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %01000010
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0175_0

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00010000
	.byte  %00101000
	.byte  %00010000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0204_1

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %01011010
	.byte  %01011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0207_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %01011010
	.byte  %01011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0210_1

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01101100
	.byte  %01110010
	.byte  %01110010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0213_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01101100
	.byte  %01110010
	.byte  %01110010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0216_1

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %00110110
	.byte  %01001110
	.byte  %01001110
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0219_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %00110110
	.byte  %01001110
	.byte  %01001110
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0223_1

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %11100110
	.byte  %00011010
	.byte  %00011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0227_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %11100110
	.byte  %00011010
	.byte  %00011010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0232_1

	.byte 0
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100111
	.byte  %01011000
	.byte  %01011000
	.byte  %00100100
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
	.byte  %00011000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0236_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00111100
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100111
	.byte  %01011000
	.byte  %01011000
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0240_1

	.byte 0
	.byte  %00001100
	.byte  %00001100
	.byte  %01001101
	.byte  %00011000
	.byte  %01011010
	.byte  %01100110
	.byte  %00100100
	.byte  %01100110
	.byte  %11000100
	.byte  %11000010
	.byte  %00100100
	.byte  %00110000
	.byte  %00110000
	.byte  %00110000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0243_1

	.byte 0
	.byte  %00010000
	.byte  %01000010
	.byte  %00011000
	.byte  %00100100
	.byte  %01000010
	.byte  %10011001
	.byte  %01000010
	.byte  %00100100
	.byte  %00011000
	.byte  %00000000
	.byte  %01000010
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
 if (<*) > (<(*+15))
	repeat ($100-<*)
	nop
	repend
	endif
playerL0246_1

	.byte 0
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00010000
	.byte  %00101000
	.byte  %00010000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
	.byte  %00000000
       echo "    ",[(scoretable - *)]d , "bytes of ROM space left")
 
 
 
; feel free to modify the score graphics - just keep each digit 8 high
; and keep the conditional compilation stuff intact
 ifconst ROM2k
   ORG $F7AC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2FA4-bscode_length
       RORG $FFA4-bscode_length
     endif
     if bankswitch == 16
       ORG $4FA4-bscode_length
       RORG $FFA4-bscode_length
     endif
     if bankswitch == 32
       ORG $8FA4-bscode_length
       RORG $FFA4-bscode_length
     endif
   else
     ORG $FFAC
   endif
 endif



scoretable
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %01111110
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00011000
       .byte %00111000
       .byte %00011000
       .byte %00001000

       .byte %01111110
       .byte %01100000
       .byte %01100000
       .byte %00111100
       .byte %00000110
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00011100
       .byte %00000110
       .byte %01000110
       .byte %00111100

       .byte %00001100
       .byte %00001100
       .byte %01111110
       .byte %01001100
       .byte %01001100
       .byte %00101100
       .byte %00011100
       .byte %00001100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00000110
       .byte %00111100
       .byte %01100000
       .byte %01100000
       .byte %01111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %01111100
       .byte %01100000
       .byte %01100010
       .byte %00111100

       .byte %00110000
       .byte %00110000
       .byte %00110000
       .byte %00011000
       .byte %00001100
       .byte %00000110
       .byte %01000010
       .byte %00111110

       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100
       .byte %01100110
       .byte %01100110
       .byte %00111100

       .byte %00111100
       .byte %01000110
       .byte %00000110
       .byte %00111110
       .byte %01100110
       .byte %01100110
       .byte %01100110
       .byte %00111100 

 ifconst ROM2k
   ORG $F7FC
 else
   ifconst bankswitch
     if bankswitch == 8
       ORG $2FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 16
       ORG $4FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
     if bankswitch == 32
       ORG $8FF4-bscode_length
       RORG $FFF4-bscode_length
     endif
   else
     ORG $FFFC
   endif
 endif

 ifconst bankswitch
   if bankswitch == 8
     ORG $2FFC
     RORG $FFFC
   endif
   if bankswitch == 16
     ORG $4FFC
     RORG $FFFC
   endif
   if bankswitch == 32
     ORG $8FFC
     RORG $FFFC
   endif
 else
   ifconst ROM2k
     ORG $F7FC
   else
     ORG $FFFC
   endif
 endif
 .word start
 .word start
